var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var import_core = require("@lerna/core");
var import_p_map = __toESM(require("p-map"));
var import_path = __toESM(require("path"));
module.exports = function factory(argv) {
  return new CleanCommand(argv);
};
class CleanCommand extends import_core.Command {
  get requiresGit() {
    return false;
  }
  initialize() {
    let chain = Promise.resolve();
    chain = chain.then(() => (0, import_core.getFilteredPackages)(this.packageGraph, this.execOpts, this.options));
    chain = chain.then((filteredPackages) => {
      this.directoriesToDelete = filteredPackages.map((pkg) => pkg.nodeModulesLocation);
    });
    return chain.then(() => {
      if (this.options.yes) {
        return true;
      }
      this.logger.info("", "Removing the following directories:");
      this.logger.info(
        "clean",
        this.directoriesToDelete.map((dir) => import_path.default.relative(this.project.rootPath, dir)).join("\n")
      );
      return (0, import_core.promptConfirmation)("Proceed?");
    });
  }
  execute() {
    this.enableProgressBar();
    const tracker = this.logger.newItem("clean");
    const mapper = (dirPath) => {
      tracker.info("clean", "removing", dirPath);
      return (0, import_core.pulseTillDone)((0, import_core.rimrafDir)(dirPath)).then(() => {
        tracker.completeWork(1);
      });
    };
    tracker.addWork(this.directoriesToDelete.length);
    return (0, import_p_map.default)(this.directoriesToDelete, mapper, { concurrency: this.concurrency }).then(() => {
      tracker.finish();
      this.logger.success("clean", "finished");
    });
  }
}
module.exports.CleanCommand = CleanCommand;
