var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var import_npmlog = __toESM(require("npmlog"));
const childProcess = require("@lerna/child-process");
module.exports.getLastCommit = getLastCommit;
function getLastCommit(execOpts) {
  if (hasTags(execOpts)) {
    import_npmlog.default.silly("getLastTagInBranch");
    return childProcess.execSync("git", ["describe", "--tags", "--abbrev=0"], execOpts);
  }
  import_npmlog.default.silly("getFirstCommit");
  return childProcess.execSync("git", ["rev-list", "--max-parents=0", "HEAD"], execOpts);
}
function hasTags(opts) {
  let result = false;
  try {
    result = !!childProcess.execSync("git", ["tag"], opts);
  } catch (err) {
    import_npmlog.default.warn("ENOTAGS", "No git tags were reachable from this branch!");
    import_npmlog.default.verbose("hasTags error", err);
  }
  import_npmlog.default.verbose("hasTags", result);
  return result;
}
