var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var package_graph_node_exports = {};
__export(package_graph_node_exports, {
  PackageGraphNode: () => PackageGraphNode
});
module.exports = __toCommonJS(package_graph_node_exports);
var import_semver = __toESM(require("semver"));
var import_prerelease_id_from_version = require("../prerelease-id-from-version");
const PKG = Symbol("pkg");
class PackageGraphNode {
  name;
  externalDependencies;
  localDependencies;
  localDependents;
  [PKG];
  constructor(pkg) {
    this.name = pkg.name;
    this[PKG] = pkg;
    Object.defineProperty(this, PKG, { enumerable: false });
    this.externalDependencies = /* @__PURE__ */ new Map();
    this.localDependencies = /* @__PURE__ */ new Map();
    this.localDependents = /* @__PURE__ */ new Map();
  }
  get location() {
    return this[PKG].location;
  }
  get pkg() {
    return this[PKG];
  }
  get prereleaseId() {
    return (0, import_prerelease_id_from_version.prereleaseIdFromVersion)(this.version);
  }
  get version() {
    return this[PKG].version;
  }
  /**
   * Determine if the Node satisfies a resolved semver range.
   * @see https://github.com/npm/npm-package-arg#result-object
   *
   * @param {!Result} resolved npm-package-arg Result object
   */
  satisfies({ gitCommittish, gitRange, fetchSpec }) {
    return import_semver.default.satisfies(this.version, gitCommittish || gitRange || fetchSpec);
  }
  /**
   * Returns a string representation of this node (its name)
   *
   * @returns {String}
   */
  toString() {
    return this.name;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PackageGraphNode
});
