var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var gitlab_client_exports = {};
__export(gitlab_client_exports, {
  GitLabClient: () => GitLabClient
});
module.exports = __toCommonJS(gitlab_client_exports);
var import_node_fetch = __toESM(require("node-fetch"));
var import_npmlog = __toESM(require("npmlog"));
var import_path = __toESM(require("path"));
class GitLabClient {
  constructor(token, baseUrl = "https://gitlab.com/api/v4") {
    this.token = token;
    this.baseUrl = baseUrl;
  }
  // TODO: refactor based on TS feedback
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  createRelease({ owner, repo, name, tag_name: tagName, body }) {
    const releasesUrl = this.releasesUrl(owner, repo, "releases");
    import_npmlog.default.silly("Requesting GitLab releases", releasesUrl);
    return (0, import_node_fetch.default)(releasesUrl, {
      method: "post",
      body: JSON.stringify({ name, tag_name: tagName, description: body }),
      headers: {
        "PRIVATE-TOKEN": this.token,
        "Content-Type": "application/json"
      }
    }).then(({ ok, status, statusText }) => {
      if (!ok) {
        import_npmlog.default.error("gitlab", `Failed to create release
Request returned ${status} ${statusText}`);
      } else {
        import_npmlog.default.silly("gitlab", "Created release successfully.");
      }
    });
  }
  releasesUrl(namespace, project) {
    return new URL(
      `${this.baseUrl}/${import_path.default.join("projects", encodeURIComponent(`${namespace}/${project}`), "releases")}`
    ).toString();
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  GitLabClient
});
