var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var serialize_placeholders_exports = {};
__export(serialize_placeholders_exports, {
  placeholderSerializer: () => placeholderSerializer
});
module.exports = __toCommonJS(serialize_placeholders_exports);
var import_path = __toESM(require("path"));
var import_serialize_tempdir = require("./serialize-tempdir");
var import_serialize_windows_paths = require("./serialize-windows-paths");
const normalizeNewline = require("normalize-newline");
const LERNA_VERSION = require(import_path.default.join(__dirname, "../../../../../", "packages/lerna/package.json")).version;
const VERSION_REGEX = new RegExp(`^((?:.*?notice cli )|\\^?)v?${LERNA_VERSION}`, "g");
function isObject(val) {
  return typeof val === "object" && !Array.isArray(val);
}
function isString(val) {
  return typeof val === "string";
}
function stableVersion(str) {
  return str.replace(VERSION_REGEX, "$1__TEST_VERSION__");
}
function stabilizeString(str) {
  return stableVersion(normalizeNewline(str));
}
const placeholderSerializer = {
  serialize: (thing, config, indentation, depth, refs, printer) => {
    if (isString(thing)) {
      let val = stabilizeString(thing);
      val = import_serialize_windows_paths.windowsPathSerializer.serialize(val, config, indentation, depth);
      val = import_serialize_tempdir.tempDirSerializer.serialize(val, config, indentation, depth);
      return val;
    }
    thing.lerna = stableVersion(thing.lerna);
    return printer(thing, config, indentation, depth, refs);
  },
  test: (thing) => {
    if (isObject(thing) && isString(thing.lerna)) {
      return VERSION_REGEX.test(thing.lerna);
    }
    return isString(thing) && (import_serialize_windows_paths.windowsPathSerializer.test(thing) || import_serialize_tempdir.tempDirSerializer.test(thing) || VERSION_REGEX.test(thing) || // always remove redundant quotes from multiline strings
    /\n/.test(thing));
  }
};
module.exports = placeholderSerializer;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  placeholderSerializer
});
