var import_core = require("@lerna/core");
const command = {
  command: "watch",
  describe: "Runs a command whenever packages or their dependents change.",
  builder(yargs) {
    yargs.parserConfiguration({
      "populate--": true,
      "strip-dashed": true
    }).option("command", { type: "string", hidden: true }).option("verbose", {
      type: "boolean",
      description: "Run watch mode in verbose mode, where commands are logged before execution."
    }).middleware((args) => {
      const { "--": doubleDash } = args;
      if (doubleDash && Array.isArray(doubleDash)) {
        args.command = doubleDash.join(" ");
      }
    }, true);
    return (0, import_core.filterOptions)(yargs);
  },
  handler(argv) {
    return require(".")(argv);
  }
};
module.exports = command;
